% Tm ajotiedosto estimoi kitkaparametrit minimoimalla nelivirheen
% Mrit datamatriisi x_ref ja painomatriisi R !


% x_ref=??;
% R=??;


mc = 2.4;  % vaunun massa
mp = 0.325; % heilurin massa
l = 0.33;  % Heilurin varren pituus


% Alkuarvot kitkaparametreille
fc = 7;
fp = 0.006;


x0 = [fc, fp]; % Optimoitavien parametrien alkuarvot,
index = [4, 5]; % Parametrit (mc=1, mp=2, l=3, fc=4, fp=5)

% ! Ohjelmalla voi mys estimoida muita parametreja. Esim. jos
% haluat optimoida l:n, mc:n, ja mp:n annetuilla kitkan arvoilla,
% aseta:
% x0=[mc mp l];
% index=[1 2 3];

% "jrkevt" ala- ja ylrajat kaikille parametreille [mc mp l fc fp] :
LBall = [1, 0.1, 0.2, 0.3, 0]';
UBall = [5, 2, 0.5, 60, 1]';

LB = LBall(index);
UB = UBall(index);
% LB = zeros(size(x0));
% UB = zeros(size(x0));
% for i = 1:max(size(x0))
%   LB(i) = LBall(index(i));
%   UB(i) = UBall(index(i));
% end


% Optimointialgoritmin parametrit:
options = optimset(...
    'LargeScale', 'off',...
    'Display', 'iter',...
    'MaxFunEvals', 10000);

% Optimointi: (estimaatit vektorissa xx, xx(1)=vaunun kitkakerroin,
% x(2)=heilurin kitkakerroin)
xx = fmincon('optpar', x0, [], [], [], [], LB, UB, [], options, x_ref,...
    R, mc, mp, l, fc, fp, index);


% Asetetaan estimoidut parametrit vektoriin parnew, miss on kaikki
% parametrit: [mc mp l fc fp]
parnew = [mc, mp, l, fc, fp];
parnew(index) = xx;
% for i = 1:max(size(xx))
%   parnew(index(i)) = xx(i);
% end

vaunun_kitka = parnew(4)
heilurin_kitka = parnew(5)

[fo, go] = pendobj(x_ref, R, parnew(1), parnew(2), parnew(3), parnew(4),...
    parnew(5));

figure(1);

% Piirretn estimoiduilla parametreilla simuloitu trajektori (sininen), sek
% todellinen trajektori (punainen).

subplot(2, 2, 1);
plot(go(:, 2), 'b');
hold on;
plot(x_ref(1, :), 'r');
grid;
hold off;
title('vaunun paikka');

subplot(2, 2, 2);
plot(go(:, 3), 'b');
hold on;
plot(x_ref(2, :), 'r');
grid;
hold off;
title('heilurin paikka');

subplot(2, 2, 3);
plot(go(:, 4), 'b');
hold on;
plot(x_ref(3, :), 'r');
grid;
hold off;
title('vaunun nopeus');

subplot(2, 2, 4);
plot(go(:, 5), 'b');
hold on;
plot(x_ref(4, :), 'r');
grid;
hold off;
title('heilurin kulmanopeus');
